# Contributing

## Structure

```
bin/fast_i18n.dart -- command line tool
lib/src/
    builder/** -- builds model objects using basic maps / lists
    generator/** -- generates output of .g.dart file using model objects
    model/** -- domain
    parser/** -- builds model objects using JSON or YAML raw strings
```

## How it works

1. `bin/fast_i18n.dart` or `lib/src/builder.dart` - Entry point
2. From JSON / YAML to model
    2.1. `parser/**` - Deserialize to common data types like `Map`
    2.2. `builder/**` - Use these common data structures to create the model
3. `generator/**` - Generate `.g.dart` output using `model/**` generated by step 2